CON

_CLKMODE     = XTAL1 + PLL16X
_XINFREQ     = 5_000_000

AYMASK       = %00000000_00000001_00000000_00000000

DAT

admsys        byte  "admym.adm",0
err           byte  "Administra-code untersttzt keine AY-Emulation!",13,0

OBJ
        ios: "ios"

VAR
  byte  AYregs[16]
  
PUB Main|i,j,k,value,playRate

  ios.start                                                 'ios initialisieren
  'ios.startram                                             'ios initialisieren
  ios.admload(@admsys)

  ' ist AY istalliert?
  ifnot ios.admgetspec & AYMASK
    ios.print(@err)
    return

  ios.bus_putchar1(200)             ' ay_start
  playRate := 5
  repeat 
    waitcnt(cnt + 80_000_000/playrate)
    repeat i from 0 to 15
      
      value := (?j)&255
      if i>9 and i<13
        value &= 31
      AYregs[i] := value
    
      ios.bus_putchar1(202)         ' ay_updateRegisters
      repeat k from 0 to 13
        ios.bus_putchar1(AYregs[k])


  ios.bus_putchar1(201)             ' ay_stop
  ios.stop
      