CON

_CLKMODE     = XTAL1 + PLL16X
_XINFREQ     = 5_000_000

AYMASK       = %00000000_00000001_00000000_00000000
playRate     = 80_000_000/50

DAT

admsys        byte  "admym.adm",0
err           byte  "Administra-code untersttzt keine AY-Emulation!",13,0

OBJ
        ios: "ios"

VAR
  byte  buffer[25]

  long  fileNumber

PUB Main | okay, k
 

  ios.start                                                 'ios initialisieren
  'ios.startram                                             'ios initialisieren
  ios.admload(@admsys)

  ' ist AY istalliert?
  ifnot ios.admgetspec & AYMASK
    ios.print(@err)
    return

  ios.bus_putchar1(200)             ' ay_start

  fileNumber := 0
  openNextFile
   
  repeat
    waitcnt(cnt+playRate)

    ios.bus_putchar1(29)           ' eof?       
    ifnot ios.bus_getchar1  
      ios.sdgetblk(16, @buffer)
      ios.bus_putchar1(202)         ' ay_updateRegisters
      repeat k from 0 to 13
        ios.bus_putchar1(buffer[k])

    else
      ios.sdclose
      fileNumber++
      openNextFile

  ios.sdclose
  ios.bus_putchar1(201)             ' ay_stop
  ios.stop


PUB openNextFile | i, j ,fn
    ios.sddir
    repeat i from 0 to fileNumber
      fn := ios.sdnext

      repeat j from 0 to strsize(fn)
        if byte[fn+j] == "."
          quit
      j++
      if byte[fn+j] <> "Y" or byte[fn+j+1] <> "M"
        i--

    ifnot ios.sdopen( "R", fn )
      ios.print(fn)
      ios.printnl

    ios.sdgetblk(14, @buffer)
    repeat 3
      ios.sdgetblk(16, @buffer)
            